jQuery(document).ready(function($){
	
	if( 'undefined' == typeof( tab_settings ) )
		return;
	
	var i;
	var tabsets = {};
	
	// Loop over the tab sets and generate tab instances
	for( i = 1; i <= tab_settings.total; i++ ) {
		var disabled;
		var settings = { show: true }; // No more fx, deprecated in tabs since jQuery UI 1.10.0, use show instead
		if( 'undefined' != typeof( tab_settings[i] ) ) {
			disabled = tab_settings[i].split(',');
			var key;
			for( key in disabled )
				disabled[key] = parseInt( disabled[key] ) - 1;
			settings.disabled = disabled;
		}
		var disabled = 'undefined' != typeof( tab_settings[i] ) ? tab_settings[i] : [];
		var theTabs = $( '#tabs-' + i + ' ul' ).children();
		
		tabsets['tabs-'+i] = { disabledTabs: disabled, enabledTabs: [] };
		
		for( var ii = 1; ii <= theTabs.length; ii++ ) {
			if( tabsets['tabs-'+i].disabledTabs.indexOf(ii) > -1 )
				continue;	
			tabsets['tabs-'+i].enabledTabs.push(ii);
		}
		// Get the leftmost and rightmost non-disabled tab
		tabsets['tabs-'+i].leftstart  = Math.min.apply( null, tabsets['tabs-'+i].enabledTabs ) - 1;
		tabsets['tabs-'+i].rightstart = Math.max.apply( null, tabsets['tabs-'+i].enabledTabs ) - 1;
		
		settings.active = tabsets['tabs-'+i].leftstart; // Set the leftmost(non-disabled) tab as the default
		$( '#tabs-'+i ).tabs(settings);
	}

	// Left / Right tab selection function
	var move_tab = function( o ) { 
		
		var tabset = $( $(this).attr('href') ).tabs();
		
		if( 'undefined' == typeof( tabset ) )
			return false;
		
		var index, condition, wrapindex, adding, setData;
		var setData = tabsets[tabset.selector.replace('#','')];
		
		if( 'undefined' == typeof( setData ) )
			return false;
		
		var direction = o.data.direction;
		var tabs = $( tabset.selector + ' ul' ).children();
		
		switch( direction ) {
			case 'left':
				index = tabset.tabs( "option", "active" ) - 1;
				condition = index > -1;
				wrapindex = setData.rightstart;
				adding = false;
			break;
			case 'right':
				index = tabset.tabs( "option", "active" ) + 1;
				condition = index < tabs.length;
				wrapindex = setData.leftstart;
				adding = true;
			break;
			default:
				return false;
		}
		
		if( 'undefined' == typeof( tabs[index] ) ) {
			tabset.tabs( 'option', 'active', wrapindex ); 
			return false;
		}
		
		while( condition ) {
			
			var tab_exists = $( tabset.selector + ' ul li:eq('+index+')' ).length == 1;
			
			if( !tab_exists ) {
				tabset.tabs( 'option', 'active', wrapindex );
				return false;
			}
			
			var is_tab_disabled = $( tabset.selector + ' ul li:eq('+index+')' ).hasClass('ui-state-disabled');
			
			if( is_tab_disabled ) {
				index = adding ? index + 1 : index - 1;
				continue;
			}
			tabset.tabs( 'option', 'active', index ); 
			break;
		}
		
		return false; 
	};
	// Attach function to click for nav buttons
	$('.put-prev').click({ direction:"left"  }, move_tab );
	$('.put-next').click({ direction:"right" }, move_tab );
});

